#typedef GLenum unsigned int
#typedef GLboolean unsigned byte
#typedef GLbitfield unsigned int
#typedef GLbyte byte
#typedef GLshort word
#typedef GLint int
#typedef GLsizei int
#typedef GLubyte unsigned byte
#typedef GLushort unsigned word
#typedef GLuint unsigned int
#typedef GLfloat float
#typedef GLclampf float
#typedef GLdouble double
#typedef GLclampd double

#typedef HDC  unsigned int
#typedef HGLRC unsigned int
#typedef HWND unsigned int
#typedef bool int
#typedef UINT unsigned int
#typedef WPARAM unsigned int
#typedef LPARAM unsigned int
#typedef COLORREF unsigned int

struct AUX_RGBImageRec {
    GLint sizeX;
	GLint sizeY;
    unsigned byte *data;
}
struct MSG
{
    HWND hwnd;
    UINT message;
    WPARAM wParam;
    LPARAM lParam;
    DWORD time;
    POINT pt;
}
struct PIXELFORMATDESCRIPTOR
{
    unsigned word  nSize;
    unsigned word  nVersion;
    DWORD dwFlags;
    BYTE  iPixelType;
    BYTE  cColorBits;
    BYTE  cRedBits;
    BYTE  cRedShift;
    BYTE  cGreenBits;
    BYTE  cGreenShift;
    BYTE  cBlueBits;
    BYTE  cBlueShift;
    BYTE  cAlphaBits;
    BYTE  cAlphaShift;
    BYTE  cAccumBits;
    BYTE  cAccumRedBits;
    BYTE  cAccumGreenBits;
    BYTE  cAccumBlueBits;
    BYTE  cAccumAlphaBits;
    BYTE  cDepthBits;
    BYTE  cStencilBits;
    BYTE  cAuxBuffers;
    BYTE  iLayerType;
    BYTE  bReserved;
    DWORD dwLayerMask;
    DWORD dwVisibleMask;
    DWORD dwDamageMask;
}

#define PM_REMOVE           0x0001
#define VK_ESCAPE         0x1B
#define VK_F1             0x70
#define VK_F2             0x71
#define VK_F3             0x72
#define VK_F4             0x73
#define VK_F5             0x74
#define VK_F6             0x75
#define VK_F7             0x76
#define VK_F11            0x7A
#define GL_PROJECTION                     0x1701 
#define GL_TEXTURE_2D                     0x0DE1
#define GL_LINEAR                         0x2601
#define GL_TEXTURE_MIN_FILTER             0x2801
#define GL_MODELVIEW                      0x1700
#define GL_LINE                           0x1B01
#define GL_FRONT_AND_BACK                 0x0408
#define GL_FILL                           0x1B02
#define GL_TEXTURE_MAG_FILTER             0x2800
#define GL_UNSIGNED_BYTE                  0x1401
#define GL_RGB                            0x1907 
#define PFD_DOUBLEBUFFER            0x00000001
#define PFD_SUPPORT_OPENGL          0x00000020
#define PFD_DRAW_TO_WINDOW          0x00000004 
#define PFD_TYPE_RGBA        0 
#define GL_DEPTH_TEST                     0x0B71
#define GL_POINTS                         0x0000 
#define GL_TRIANGLE_STRIP                 0x0005 
#define GL_COMPILE                        0x1300
#define GL_DEPTH_BUFFER_BIT               0x00000100
#define GL_COLOR_BUFFER_BIT               0x00004000 
#define GL_T2F_N3F_V3F                    0x2A2B

import void glColor3f (GLfloat red, GLfloat green, GLfloat blue);
declare import,GetDC(opt HWND hWnd),HDC;
declare import,ReleaseDC(HWND hWnd,HDC hDC),int;
declare import, SetTextColor(HDC hdc, COLORREF color),COLORREF;
declare import, TextOut alias TextOutA(HDC hdc, int x, int y, string* lpString, int c),BOOL;
declare import, wglDeleteContext(HGLRC h),BOOL;
import void glBegin (GLenum mode);
import void glTexImage2D (GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLint border, GLenum format, GLenum type, void *pixels);
import void glCallList (GLuint list);
import void glViewport (GLint x, GLint y, GLsizei width, GLsizei height);
import void glTexParameteri (GLenum target, GLenum pname, GLint param);
import void glDeleteTextures (GLsizei n, GLuint *textures);
import void glDrawArrays (GLenum mode, GLint first, GLsizei count);
import void glEnable (GLenum cap);
import void cdecl free(void *mem);
import void glClear (GLbitfield mask);
import void glVertex3f (GLfloat x, GLfloat y, GLfloat z);
import void gluPerspective (GLdouble fovy, GLdouble aspect, GLdouble zNear, GLdouble zFar);
import void glMatrixMode (GLenum mode);
declare import, wglCreateContext(HDC h),HGLRC;
import void glLoadIdentity ();
declare import, SetPixelFormat(HDC hdc, int format, PIXELFORMATDESCRIPTOR *ppfd),BOOL;


declare import,UpdateWindow(HWND hWnd),BOOL; 
declare import, SwapBuffers(HDC h),BOOL;
declare import,PeekMessage alias PeekMessageA( MSG *lpMsg,opt HWND hWnd,UINT wMsgFilterMin,UINT wMsgFilterMax,UINT wRemoveMsg),BOOL;
declare import,TranslateMessage(MSG *lpMsg),BOOL;
import void glRotatef (GLfloat angle, GLfloat x, GLfloat y, GLfloat z);
import void glTexCoord2f (GLfloat s, GLfloat t);
import void glGenTextures (GLsizei n, GLuint *textures); 
declare import, ChoosePixelFormat(HDC hdc, PIXELFORMATDESCRIPTOR *ppfd),int;
import void glPolygonMode (GLenum face, GLenum mode);
import int cdecl memset(void* mem,byte b,int count);
import void glInterleavedArrays (GLenum format, GLsizei stride, void *ptr); 
import void glBindTexture (GLenum target, GLuint texture);
import void glNewList (GLuint list, GLenum mode); 
declare import,DispatchMessage alias DispatchMessageA(MSG *lpMsg),LRESULT;
import void glEndList ();
import void glNormal3f (GLfloat nx, GLfloat ny, GLfloat nz);
declare import,Sleep(DWORD dwMilliseconds); 
declare import, glGenLists (GLsizei range),GLuint;
import void glDeleteLists (GLuint list, GLsizei range);
import void glTranslatef (GLfloat x, GLfloat y, GLfloat z);
import void glClearColor (GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha);
declare import, wglMakeCurrent(HDC h, HGLRC h),BOOL;
extern pointer auxDIBImageLoad alias auxDIBImageLoadA(string* s);
import void glEnd ();
